<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>EquationParser.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Calculator</a> &gt; <a href="index.source.html" class="el_package">service</a> &gt; <span class="el_source">EquationParser.java</span></div><h1>EquationParser.java</h1><pre class="source lang-java linenums">package service;

import java.util.*;

/**
 * this class can split an equation string into tokens and return the newly created list in postfix form
 */
<span class="nc" id="L8">public class EquationParser {</span>

    /**
     * @param s the operator whose priority is decided
     * @return 1 - (for + and - );
     *         2 - (for * and / );
     *         0 - (for anything else)
     */
    private static int priority(String s) {
<span class="fc" id="L17">        return</span>
<span class="pc bpc" id="L18" title="1 of 3 branches missed.">                switch (s) {</span>
<span class="fc" id="L19">                    case &quot;+&quot;, &quot;-&quot; -&gt; 1;</span>
<span class="fc" id="L20">                    case &quot;*&quot;, &quot;/&quot; -&gt; 2;</span>
<span class="nc" id="L21">                    default -&gt; 0;</span>
                };
    }

    /**
     * @param equation as a string
     * @return a list containing the tokens (no whitespaces) in the order in which they appear
     *         NOTE: a token is either an operator(+,-,/,*), a number (e.q.: 2, 3.045 ...) or
     *               a construct such as max(1,2), min(0.47, 5), sqrt(0.49)
     */
    private static List&lt;String&gt; splitEquation(String equation) {
<span class="fc" id="L32">        return List.of(equation.trim().replace(&quot; &quot;, &quot;&quot;).split(&quot;((?&lt;=[-+/*])|(?=[-+/*]))&quot;));</span>
    }

    /**
     * @param equation to be passed as a string
     * @return a list of tokens explained above in postfix form
     */
    public static List&lt;String&gt; parseEquation(String equation) {
<span class="fc" id="L40">        List&lt;String&gt; parsed = splitEquation(equation);</span>
<span class="fc" id="L41">        parsed = convertToPostFixed(parsed);</span>
<span class="fc" id="L42">        return parsed;</span>
    }

    /**
     * @param exp a list of tokens extracted from an expression
     * @return another list of the same tokens but in postfix form, making it easier for later processing
     *
     *  NOTE: at each operator verification checkpoint we also check for priority and take decisions accordingly
     */
    private static List&lt;String&gt; convertToPostFixed(List&lt;String&gt; exp) {
<span class="fc" id="L52">        List&lt;String&gt; exprs = new ArrayList&lt;&gt;();</span>
<span class="fc" id="L53">        Stack&lt;String&gt; stack = new Stack&lt;&gt;();</span>

<span class="fc bfc" id="L55" title="All 2 branches covered.">        for (String s : exp) {</span>
<span class="fc bfc" id="L56" title="All 2 branches covered.">            if (s.matches(&quot;^[-+/*]$&quot;)) {</span>
<span class="fc bfc" id="L57" title="All 4 branches covered.">                while (!stack.isEmpty() &amp;&amp; priority(s) &lt;= priority(stack.peek())) {</span>
<span class="fc" id="L58">                    exprs.add(stack.peek());</span>
<span class="fc" id="L59">                    stack.pop();</span>
                }
<span class="fc" id="L61">                stack.push(s);</span>
            } else
<span class="fc" id="L63">                exprs.add(s);</span>
<span class="fc" id="L64">        }</span>

<span class="fc bfc" id="L66" title="All 2 branches covered.">        while (!stack.isEmpty()) {</span>
<span class="fc" id="L67">            exprs.add(stack.peek());</span>
<span class="fc" id="L68">            stack.pop();</span>
        }
<span class="fc" id="L70">        return exprs;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>